From: Apollon Oikonomopoulos <apoikos@debian.org>
Date: Mon, 4 Apr 2022 17:18:49 +0200
Subject: Fix FTBFS with GCC 7

Bug-Debian: https://bugs.debian.org/853556
Last-Update: 2023-07-18
Forwarded: no

GCC 7 warns us that the mangled symbol names of various functions are due to
change in C++17:
  src/mongo/util/scopeguard.h:154:7: error: mangled name for 'mongo::ScopeGuardImpl1<void (*)(void*) throw (), char*>::ScopeGuardImpl1(const mongo::ScopeGuardImpl1<void (*)(void*) throw (), char*>&)' will change in C++17 because the exception specification is part of a function type [-Werror=c++1z-compat]
This appears to be mostly harmless in our case, since we're not building a
shared library. Also, MongoDB 3.2 does not boast C++17 compatibility.
Fix this by treating all C++17-compat errors as warnings.
Additionally turn format truncation errors back to warnings again for the time
being.
---
 SConstruct | 4 ++++
 1 file changed, 4 insertions(+)

diff --git a/SConstruct b/SConstruct
index 3361c2b..b19c994 100644
--- a/SConstruct
+++ b/SConstruct
@@ -3042,6 +3042,10 @@ if env.TargetOSIs('posix'):
             "-Wsign-compare",
             "-Wno-unknown-pragmas",
             "-Winvalid-pch",
+			"-Wno-error=c++1z-compat",
+			"-Wno-error=noexcept-type",
+			"-Wno-error=format-truncation",
+			"-Wno-error=int-in-bool-context",
         ], )
 
     if env.get('DWARF_VERSION'):
